﻿Module En_tcpip_VISA

    Public MacAddress As String    'ＭＡＣアドレス
    Public NowIpAddress As String  '現在のＩＰアドレス
    Public NowPortNo As Long    '現在のポート番号
    Public Delim As String      'デリミタコード
    Public DelimByte As Byte    'デリミタコード

    Dim RM As New Ivi.Visa.Interop.ResourceManager
    Dim DMM As New Ivi.Visa.Interop.FormattedIO488
    'System.Runtime.InteropServices.Marshal.ReleaseComObject(DMM)
    'System.Runtime.InteropServices.Marshal.ReleaseComObject(RM)

    Private Function En_Calc_IPA() As Long
        Dim Ipa(4) As Long
        Dim nn As Integer
        Dim ss As String
        Dim mm As Integer

        ss = NowIpAddress
        For mm = 1 To 4
            nn = InStr(ss, ".")
            If nn < 2 And mm < 4 Then 'エラー
                En_Calc_IPA = -1
                Exit Function
            End If
            If mm = 4 Then
                Ipa(mm) = Mid(ss, 1)
            Else
                Ipa(mm) = Mid(ss, 1, nn - 1)
                ss = Mid(ss, nn + 1)
            End If
        Next

        En_Calc_IPA = 0
        For mm = 4 To 1 Step -1
            En_Calc_IPA = Ipa(mm) + (En_Calc_IPA * 256)
        Next
        Return En_Calc_IPA
    End Function

    Private Function En_Tcpip_Connect() As Long '接続する
        Dim IPA As Long
        Dim ret As Long
        Dim eMsg As String

        On Error GoTo Cerr
        DMM.IO = RM.Open("TCPIP0::" & NowIpAddress & "::" & Str(NowPortNo) & "::SOCKET")
        On Error GoTo -1
        Return 0
Cerr:
        eMsg = "Error # " & Str(Err.Number) & " was generated by " & Err.Source & ControlChars.CrLf & Err.Description
        MsgBox(eMsg, MsgBoxStyle.Information, "Error" & " in Function En_Tcpip_Connect()")

        Return -1

    End Function

    Private Function En_Tcpip_Send(ByVal SendDT As String) As Long
        Dim eMsg As String

        On Error GoTo TransErr
        DMM.IO.WriteString(SendDT)
        On Error GoTo 0
        Return 0
TransErr:
        eMsg = "Error # " & Str(Err.Number) & " was generated by " & Err.Source & ControlChars.CrLf & Err.Description
        MsgBox(eMsg, MsgBoxStyle.Information, "Error" & " in Function En_Tcpip_Send()")
        Return -1

    End Function

    Private Function En_Tcpip_Rec(ByRef RecDT As String) As Long
        '受信する
        Dim ret As Long
        Dim dlmByte As Byte
        Dim eMsg As String

        On Error GoTo Rerr
        DMM.IO.TerminationCharacterEnabled = True
        ret = Len(Delim)
        If ret > 1 Then
            ret = ret - 1
        End If
        DlmByte = Asc(Mid(Delim, ret))
        DMM.IO.TerminationCharacter = DlmByte
        RecDT = DMM.ReadString()
        On Error GoTo 0

        Return 0

Rerr:
        eMsg = "Error # " & Str(Err.Number) & " was generated by " & Err.Source & ControlChars.CrLf & Err.Description
        MsgBox(eMsg, MsgBoxStyle.Information, "Error" & " in Function En_Tcpip_Rec()")
        Call DispStr(Form1.TextBox4, " 失敗" & vbCrLf)

        Return -1
    End Function

    ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
    Public Function En_Set_IpAddress(ByVal No As String) As Long

        NowIpAddress = No '現在のＩＰアドレス

        Return 0
    End Function

    Public Function En_Set_PortNo(ByVal No As Long) As Long

        NowPortNo = No '現在のポート番号

        Return 0
    End Function

    Public Function En_SendStr(ByVal SDT As String, ByVal dlm As String) As Long
        Dim ret As Long

        Call DispStr(Form1.TextBox4, vbCrLf & "接続する・・・・")
        ret = En_Tcpip_Connect()    '接続要求
        If ret < 0 Then '接続失敗
            Call DispStr(Form1.TextBox4, " 接続失敗" & vbCrLf)
            Return ret
        End If
        Call DispStr(Form1.TextBox4, " 接続成功！" & vbCrLf)

        Call DispStr(Form1.TextBox4, "　設定コマンド[" & SDT & "]" & vbCrLf)
        Call DispStr(Form1.TextBox4, "　設定する・・・・")
        ret = En_Tcpip_Send(SDT & dlm)
        If ret < 0 Then '失敗
            Call DispStr(Form1.TextBox4, " 失敗->接断する" & vbCrLf)
        Else
            Call DispStr(Form1.TextBox4, " 成功！" & vbCrLf)
        End If

        Call DispStr(Form1.TextBox4, " 接断する" & vbCrLf)
        DMM.IO.Close()              '接断要求
        Return ret

    End Function

    Private Function En_DelimCheck(ByVal rdt As String) As String
        Dim NN As Integer
        Dim MM As Integer
        Dim resMsg As String = ""
        Dim ST1 As String
        Dim ST2 As String

        For MM = 0 To &H1F
            NN = InStr(rdt, Chr(MM))
            If NN <> 0 Then
                ST1 = Mid(rdt, 1, NN - 1)
                If Len(rdt) = NN Then
                    ST2 = ""
                Else
                    ST2 = Mid(rdt, NN + 1)
                End If
                resMsg = ST1 & "<" & Hex(MM) & ">" & ST2
            End If
        Next
        En_DelimCheck = resMsg
    End Function

    Public Function En_SendRecStr(ByVal SDT As String, ByRef RDT As String, ByVal dlm As String) As Long
        Dim ret As Long

        Call DispStr(Form1.TextBox4, vbCrLf & "接続する・・・・")
        ret = En_Tcpip_Connect()    '接続要求
        If ret < 0 Then '接続失敗
            Call DispStr(Form1.TextBox4, " 接続失敗" & vbCrLf)
            Return -1
        End If
        Call DispStr(Form1.TextBox4, " 接続成功！" & vbCrLf)

        Call DispStr(Form1.TextBox4, "　問合コマンド[" & SDT & "]" & vbCrLf)
        Call DispStr(Form1.TextBox4, "　問い合わせる・・・・")
        ret = En_Tcpip_Send(SDT & dlm)
        If ret < 0 Then '失敗
            Call DispStr(Form1.TextBox4, " 失敗->接断する" & vbCrLf)
            DMM.IO.Close()
            Return -1
        End If
        Call DispStr(Form1.TextBox4, " 成功！" & vbCrLf)

        Call DispStr(Form1.TextBox4, "　応答を得る・・・・")
        '問合せコマンドなので応答を得る
        ret = En_Tcpip_Rec(SDT)
        If ret < 0 Then '失敗
            Call DispStr(Form1.TextBox4, " 失敗->接断する" & vbCrLf)
            DMM.IO.Close()
            Return -1
        End If
        Call DispStr(Form1.TextBox4, " 成功！" & vbCrLf)

        RDT = SDT
        SDT = En_DelimCheck(SDT)
        Call DispStr(Form1.TextBox4, "　応答[" & SDT & "]" & vbCrLf)
        Call DispStr(Form1.TextBox4, " 接断する" & vbCrLf)
        DMM.IO.Close()              '接断要求
        Return 0

    End Function
End Module
